
#include "Capri.h"
#include "LibCapriCRM.h"

// register a utility and utility constraint specification to the CAPRI core
// parse these specifications to a tree structure
INT registerUtility(const FlowID *id, char *utilSpec, char *utilConst, APP_TYPE appType);

// deregister a flow from UtilityTable
INT deregisterUtility(const INT fid);
	
typedef enum _CAPRI_ACTION_TYPE{
	CAPRI_REGISTER_UTILITY = 111,
	CAPRI_DEREGISTER_UTILITY,
	CAPRI_RETURN_ID,
	CAPRI_GET_ATTRIBUTE,
	CAPRI_SET_ATTRIBUTE,
	DECREASE_PARAMETER,
	INCREASE_PARAMETER,

} CAPRI_ACTION_TYPE;

