#ifndef lint
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 31 "usl.y"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>
#include <ctype.h>
#include "node.h"

struct utilityTree *opr(int oper, int nops, ...);
struct utilityTree *name(int i);
struct utilityTree *val(float value);
char *ToLower(char *string);
float compute(utilityTree *p);

void yyerror(char *s);
void yy_scan_string(char *s);
int yylex();


float test[100];
utilityTree *out;
char *undefined_name;
#line 55 "usl.y"
typedef union {
	int attval;
	float floatval;
	char *strval;
	struct utilityTree *nPtr;

} YYSTYPE;
#line 43 "y_tab.c"
#define INTEGER 257
#define NAME 258
#define FLOATNUM 259
#define LCON 260
#define RCON 261
#define POW 262
#define LCON2 263
#define RCON2 264
#define EXP 265
#define LOG 266
#define LN 267
#define SQRT 268
#define MIN 269
#define MAX 270
#define SIN 271
#define SINH 272
#define COS 273
#define COSH 274
#define TAN 275
#define TANH 276
#define DIV 277
#define GE 278
#define LE 279
#define EQ 280
#define NE 281
#define GT 282
#define LT 283
#define DELIM 284
#define UMINUS 285
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    4,    4,    4,    6,    6,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    3,    3,    3,    3,
    3,    3,    3,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    1,    1,
};
short yylen[] = {                                         2,
    0,    1,    0,    3,    1,    1,    2,    1,    1,    1,
    3,    3,    3,    4,    4,    4,    3,    3,    5,    3,
    3,    3,    3,    3,    4,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    3,    1,
};
short yydefred[] = {                                      0,
    8,   45,    9,    0,    0,   34,   35,   36,   37,   38,
   39,   40,   41,   42,   43,    0,    0,    0,   10,    0,
    2,    0,    0,    0,    0,    0,    0,    6,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   29,   30,
   32,   31,   27,   28,   33,    0,    0,    0,    0,   22,
   23,   44,   21,    4,    7,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   25,   14,   15,   16,
    0,    0,
};
short yydgoto[] = {                                      18,
   19,   20,   48,   21,   22,   30,
};
short yysindex[] = {                                    415,
    0,    0,    0,  591,  591,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  591,  415,    0,    0,  -34,
    0,  535,  591,  436,  444,  -40,  -32,    0,  469,  571,
  415,  591,  591,  591,  591,  591,  591,  591,    0,    0,
    0,    0,    0,    0,    0,  591,  591,  591,  469,    0,
    0,    0,    0,    0,    0,  -23,  477,  535,  502,  543,
  543,  310,  310,  510,  535,  535,    0,    0,    0,    0,
  591,  535,
};
short yyrindex[] = {                                      7,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -22,    0,    0,    0,
    0,  199,    0,    0,    0,    1,  -30,    0, -146,    0,
  -22,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  115,    0,   73,
   94,   29,   50,    0,  136,  157,    0,    0,    0,    0,
    0,  178,
};
short yygindex[] = {                                      0,
  -15,    0,  -61,  -14,   31,    0,
};
#define YYTABLESIZE 867
short yytable[] = {                                      46,
   26,   27,   28,   47,   71,   31,    1,   27,   52,   10,
   71,   10,   10,   10,   10,   55,   56,   67,    3,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   13,    0,
    0,    0,    0,    0,   24,   25,    0,    0,    0,    0,
    0,   26,   26,   26,    0,   26,   26,   29,    0,   17,
    0,    0,    0,   49,    0,    0,    0,    0,    0,    0,
    0,    0,   57,   58,   59,   60,   61,   62,   63,   13,
   13,   13,   11,   13,    0,    0,   64,   65,   66,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   17,   17,   17,   12,   17,    0,    0,    0,    0,    0,
    0,   72,    0,    0,    0,    0,    0,    0,    0,    0,
    5,    5,    5,   11,   18,   11,    0,   11,    5,    5,
    5,    5,    0,    0,    5,    5,    5,    5,    5,    5,
    0,    0,    0,    0,   12,   24,   12,    0,   12,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   18,   20,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   24,   19,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   20,    5,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   19,   32,
    0,   33,   34,    0,    0,    0,   10,   10,   10,   10,
    0,   10,   10,    0,   10,   10,   10,   10,    0,    5,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,    0,    0,    0,   26,   26,   26,
    0,   26,    0,    0,   26,   26,   26,   26,   26,    0,
    0,   26,   26,   26,   26,   26,   26,   26,   26,   26,
   26,   26,   26,   26,   26,   13,   13,   13,    0,   13,
    0,    0,   13,   13,   13,   13,   13,    0,    0,   13,
   13,   13,   13,   13,   13,   13,   17,   17,   17,    0,
   17,    0,    0,   17,   17,   17,   17,   17,    0,    0,
   17,   17,   17,   17,   17,   17,   17,    0,    0,   11,
   11,   11,    0,   11,    0,    0,   11,   11,   11,   11,
   11,    0,    0,   11,   11,   11,   11,   11,   11,   46,
   12,   12,   12,   47,   12,    0,    0,   12,   12,   12,
   12,   12,    0,    0,   12,   12,   12,   12,   12,   12,
    0,   18,   18,   18,    0,   18,    0,    0,   18,   18,
   18,   18,   18,    0,    0,   18,   18,   18,   18,   18,
   18,    0,   24,   24,   24,    0,   24,    0,    0,   24,
   24,   24,   24,   24,    0,    0,   24,   24,   24,   24,
   24,   24,    0,   20,   20,   20,    0,   20,    0,    0,
   20,   20,   20,   20,   20,    0,    0,   20,   20,   20,
   20,   20,   20,    0,   19,   19,   19,    0,   19,    0,
    0,   19,   19,   19,   19,   19,    0,    0,   19,   19,
   19,   19,   19,   19,   17,    5,    5,    5,    0,   16,
    0,    0,    0,    5,    5,    5,    5,    0,    0,    5,
    5,    5,    5,    5,    5,   46,    0,   37,   35,   47,
   36,    0,    0,   46,    0,   37,   35,   47,   36,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   46,   53,
   37,   35,   47,   36,    0,    0,   46,    0,   37,   35,
   47,   36,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   46,    0,   37,   35,   47,   36,    0,    0,   46,
   70,   37,   35,   47,   36,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   32,
    0,   33,   34,    0,   46,    0,   37,   35,   47,   36,
    0,    0,   46,    0,   37,    0,   47,   39,   40,   41,
   42,   43,   44,   45,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   17,   54,    0,    0,    0,   16,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   23,    0,    0,    0,    0,   16,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    1,    2,    3,    4,    0,    0,    5,    0,    6,
    7,    8,    9,    0,    0,   10,   11,   12,   13,   14,
   15,    0,    0,    0,    0,   32,   50,   33,   34,    0,
    0,    0,    0,   32,    0,   33,   34,   51,    0,    0,
    0,    0,   38,   39,   40,   41,   42,   43,   44,   45,
   38,   39,   40,   41,   42,   43,   44,   45,   32,    0,
   33,   34,    0,    0,    0,    0,   32,   68,   33,   34,
    0,    0,    0,    0,    0,   38,   39,   40,   41,   42,
   43,   44,   45,   38,   39,   40,   41,   42,   43,   44,
   45,   32,    0,   33,   34,   69,    0,    0,    0,   32,
    0,   33,   34,    0,    0,    0,    0,    0,   38,   39,
   40,   41,   42,   43,   44,   45,   38,   39,   40,   41,
   42,   43,   44,   45,   32,    0,   33,   34,    0,    0,
    0,    0,   32,    0,   33,   34,    0,    0,    0,    0,
    0,   38,   39,   40,   41,   42,   43,   44,   45,   38,
   39,   40,   41,   42,   43,   44,   45,    1,    2,    3,
    4,    0,    0,    5,    0,    6,    7,    8,    9,    0,
    0,   10,   11,   12,   13,   14,   15,    1,    2,    3,
    4,    0,    0,    5,    0,    6,    7,    8,    9,    0,
    0,   10,   11,   12,   13,   14,   15,
};
short yycheck[] = {                                      40,
    0,   17,   17,   44,   66,   40,    0,   23,   41,   40,
   72,   42,   43,   44,   45,   30,   31,   41,   41,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,
   -1,   -1,   -1,   -1,    4,    5,   -1,   -1,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,   16,   17,   -1,    0,
   -1,   -1,   -1,   23,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   32,   33,   34,   35,   36,   37,   38,   41,
   42,   43,    0,   45,   -1,   -1,   46,   47,   48,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   41,   42,   43,    0,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   71,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,  258,  259,   41,    0,   43,   -1,   45,  265,  266,
  267,  268,   -1,   -1,  271,  272,  273,  274,  275,  276,
   -1,   -1,   -1,   -1,   41,    0,   43,   -1,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   41,    0,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   41,    0,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,  260,
   -1,  262,  263,   -1,   -1,   -1,  257,  258,  259,  260,
   -1,  262,  263,   -1,  265,  266,  267,  268,   -1,   41,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,   -1,   -1,   -1,  257,  258,  259,
   -1,  261,   -1,   -1,  264,  265,  266,  267,  268,   -1,
   -1,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  257,  258,  259,   -1,  261,
   -1,   -1,  264,  265,  266,  267,  268,   -1,   -1,  271,
  272,  273,  274,  275,  276,  277,  257,  258,  259,   -1,
  261,   -1,   -1,  264,  265,  266,  267,  268,   -1,   -1,
  271,  272,  273,  274,  275,  276,  277,   -1,   -1,  257,
  258,  259,   -1,  261,   -1,   -1,  264,  265,  266,  267,
  268,   -1,   -1,  271,  272,  273,  274,  275,  276,   40,
  257,  258,  259,   44,  261,   -1,   -1,  264,  265,  266,
  267,  268,   -1,   -1,  271,  272,  273,  274,  275,  276,
   -1,  257,  258,  259,   -1,  261,   -1,   -1,  264,  265,
  266,  267,  268,   -1,   -1,  271,  272,  273,  274,  275,
  276,   -1,  257,  258,  259,   -1,  261,   -1,   -1,  264,
  265,  266,  267,  268,   -1,   -1,  271,  272,  273,  274,
  275,  276,   -1,  257,  258,  259,   -1,  261,   -1,   -1,
  264,  265,  266,  267,  268,   -1,   -1,  271,  272,  273,
  274,  275,  276,   -1,  257,  258,  259,   -1,  261,   -1,
   -1,  264,  265,  266,  267,  268,   -1,   -1,  271,  272,
  273,  274,  275,  276,   40,  257,  258,  259,   -1,   45,
   -1,   -1,   -1,  265,  266,  267,  268,   -1,   -1,  271,
  272,  273,  274,  275,  276,   40,   -1,   42,   43,   44,
   45,   -1,   -1,   40,   -1,   42,   43,   44,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   -1,   -1,   40,   -1,   42,   43,
   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   42,   43,   44,   45,   -1,   -1,   40,
   41,   42,   43,   44,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  260,
   -1,  262,  263,   -1,   40,   -1,   42,   43,   44,   45,
   -1,   -1,   40,   -1,   42,   -1,   44,  278,  279,  280,
  281,  282,  283,  284,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   41,   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,   -1,   -1,  263,   -1,  265,
  266,  267,  268,   -1,   -1,  271,  272,  273,  274,  275,
  276,   -1,   -1,   -1,   -1,  260,  261,  262,  263,   -1,
   -1,   -1,   -1,  260,   -1,  262,  263,  264,   -1,   -1,
   -1,   -1,  277,  278,  279,  280,  281,  282,  283,  284,
  277,  278,  279,  280,  281,  282,  283,  284,  260,   -1,
  262,  263,   -1,   -1,   -1,   -1,  260,  261,  262,  263,
   -1,   -1,   -1,   -1,   -1,  277,  278,  279,  280,  281,
  282,  283,  284,  277,  278,  279,  280,  281,  282,  283,
  284,  260,   -1,  262,  263,  264,   -1,   -1,   -1,  260,
   -1,  262,  263,   -1,   -1,   -1,   -1,   -1,  277,  278,
  279,  280,  281,  282,  283,  284,  277,  278,  279,  280,
  281,  282,  283,  284,  260,   -1,  262,  263,   -1,   -1,
   -1,   -1,  260,   -1,  262,  263,   -1,   -1,   -1,   -1,
   -1,  277,  278,  279,  280,  281,  282,  283,  284,  277,
  278,  279,  280,  281,  282,  283,  284,  257,  258,  259,
  260,   -1,   -1,  263,   -1,  265,  266,  267,  268,   -1,
   -1,  271,  272,  273,  274,  275,  276,  257,  258,  259,
  260,   -1,   -1,  263,   -1,  265,  266,  267,  268,   -1,
   -1,  271,  272,  273,  274,  275,  276,
};
#define YYFINAL 18
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 285
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'","'+'","','","'-'",0,"'/'",0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"INTEGER","NAME","FLOATNUM","LCON","RCON","POW","LCON2","RCON2","EXP","LOG",
"LN","SQRT","MIN","MAX","SIN","SINH","COS","COSH","TAN","TANH","DIV","GE","LE",
"EQ","NE","GT","LT","DELIM","UMINUS",
};
char *yyrule[] = {
"$accept : start",
"start :",
"start : stmt",
"stmt :",
"stmt : '(' stmt_list ')'",
"stmt : expr",
"stmt_list : stmt",
"stmt_list : stmt_list stmt",
"expr : INTEGER",
"expr : FLOATNUM",
"expr : attribute",
"expr : expr '+' expr",
"expr : expr '-' expr",
"expr : expr '*' expr",
"expr : expr LCON expr RCON",
"expr : expr LCON2 expr RCON2",
"expr : expr '(' expr ')'",
"expr : expr DIV expr",
"expr : expr POW expr",
"expr : expr cond expr cond expr",
"expr : expr cond expr",
"expr : '(' expr ')'",
"expr : LCON expr RCON",
"expr : LCON2 expr RCON2",
"expr : expr ',' expr",
"expr : function '(' stmt ')'",
"expr : '-' expr",
"cond : GT",
"cond : LT",
"cond : GE",
"cond : LE",
"cond : NE",
"cond : EQ",
"cond : DELIM",
"function : EXP",
"function : LOG",
"function : LN",
"function : SQRT",
"function : SIN",
"function : SINH",
"function : COS",
"function : COSH",
"function : TAN",
"function : TANH",
"attribute : '(' attribute ')'",
"attribute : NAME",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 361 "usl.y"

// test compute function to evaluate the utility values
float compute(utilityTree *p) {
	float t0, t1;
	if(!p) {
		printf("NULL vector - return\n");
		return 0;
	}
	switch(p->type) {
		case TYPE_VALUE:
			return p->val.value;
		break;
		case TYPE_NAME:
			return test[p->name.i];
		break;
		case TYPE_OP:
			switch(p->op.oper) {
			
				case UMINUS:
					return -compute(p->op.op[0]);
				break;
				case OP_ADD:
					t0 = compute(p->op.op[0]);
					t1 = compute(p->op.op[1]);
					return t0 + t1;
				break;
				case OP_SUB:
					t0 = compute(p->op.op[0]);
					t1 = compute(p->op.op[1]);
					return t0 - t1;
				break;
				case OP_MUL:
					t0 = compute(p->op.op[0]);
					t1 = compute(p->op.op[1]);
					return t0 * t1;
				break;
				case OP_DIV:
					t0 = compute(p->op.op[0]);
					t1 = compute(p->op.op[1]);
					if (t1)
						return t0 / t1;
					else {
						printf("divided by ZERO\n");
						return 0;
					}
				break;
				case OP_EQ:
					return (float)(compute(p->op.op[0]) == compute(p->op.op[1]));
				break;
				case OP_NE:
					return (float)(compute(p->op.op[0]) != compute(p->op.op[1]));
				break;
				case OP_GT:
					return (float)(compute(p->op.op[0]) > compute(p->op.op[1]));
				break;
				case OP_GE:
					return (float)(compute(p->op.op[0]) >= compute(p->op.op[1]));
				break;
				case OP_LT:
					t0 = compute(p->op.op[0]);
					t1 = compute(p->op.op[1]);
					return (float)(t0 < t1);
				break;
				case OP_LE:
					t0 = compute(p->op.op[0]);
					t1 = compute(p->op.op[1]);
					return (float)(t0 <= t1);
				break;
				case OP_EXP:
					return (float)(exp(compute(p->op.op[0])));
				break;
				case OP_LOG:
					return (float)(log10(compute(p->op.op[0])));
				break;
				case OP_LN:
					return (float)(log(compute(p->op.op[0])));
				break;
				case OP_SQRT:
					return (float)(sqrt(compute(p->op.op[0])));
				break;
				case OP_POW:
					return (float)(pow(compute(p->op.op[0]), compute(p->op.op[1])));
				break;
				case OP_CM:
					return 0;
				break;
				case OP_SIN:
					return (float)(sin(compute(p->op.op[0])));
				break;
				case OP_SINH:
					return (float)(sinh(compute(p->op.op[0])));
				break;
				case OP_COS:
					return (float)(cos(compute(p->op.op[0])));
				break;
				case OP_COSH:
					return (float)(cosh(compute(p->op.op[0])));
				break;
				case OP_TAN:
					return (float)(tan(compute(p->op.op[0])));
				break;
				case OP_TANH:
					return (float)(tanh(compute(p->op.op[0])));
				break;
			}
			default:
			return 0;
			break;
	
	}
	
}

struct utilityTree *val(float value) {
	utilityTree *p;
	size_t nodeSize;
	nodeSize = 4 + sizeof(valNodeType);
	p = (utilityTree *)malloc(nodeSize);
	if (p == NULL)
	{
		printf("out of memory");
	}
	p->type = TYPE_VALUE;
	p->val.value = value;
	
	return (struct utilityTree *)p;
}	

struct utilityTree *name(int i) {
	utilityTree *p;
	size_t nodeSize;
	nodeSize = 4 + sizeof(int);
	if ((p = (utilityTree *)malloc(nodeSize)) == NULL)
	{
		printf("out of memory");
	}
	
	p->type = TYPE_NAME;
	p->name.i = i;
	if (i < 0) {
		p->name.un = (char *)malloc(strlen(undefined_name));
		//strcpy_s(p->name.un, (int)strlen(undefined_name), undefined_name);
		strcpy(p->name.un, undefined_name);
	} 
	return (struct utilityTree *)p;
}

struct utilityTree *opr(int oper, int nops, ...) {
	va_list vl;
	utilityTree *p;
	size_t nodeSize;
	int i;
	nodeSize = 4 + sizeof(opNodeType) + (nops - 1) * sizeof(utilityTree *);
	if ((p = malloc(nodeSize)) == NULL)
	{
		printf("out of memory");
	}
		
	p->type = TYPE_OP;
	p->op.oper = oper;
	p->op.nops = nops;
	va_start(vl, nops);
	for(i = 0; i < nops; i++) {
		p->op.op[i] = va_arg(vl, utilityTree *);
	}
	va_end(vl);	
	
	return (struct utilityTree *)p;
}

char *ToLower(char *st) {
  int i;
  for(i=0; i < (int)strlen(st); i++)
    st[i] = tolower(st[i]);
  return st;
}

//-------------------------------------------------------------------------------------------------//

// to parse a given utility functions
utilityTree * attach_utility(char *query) {
	
  yy_scan_string(query);
	if(!yyparse()) {
		return out;
	}
	else
	{
		printf("CAPRI parse failed\n");
	}

  return NULL;

}

	
#line 589 "y_tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 85 "usl.y"
{ 
	}
break;
case 2:
#line 88 "usl.y"
{
		out = yyvsp[0].nPtr;
	}
break;
case 3:
#line 94 "usl.y"
{	
	}
break;
case 4:
#line 97 "usl.y"
{	
		yyval.nPtr = yyvsp[-1].nPtr;
	}
break;
case 5:
#line 101 "usl.y"
{	
		yyval.nPtr = yyvsp[0].nPtr;
	}
break;
case 6:
#line 108 "usl.y"
{
		yyval.nPtr =yyvsp[0].nPtr;
	}
break;
case 7:
#line 112 "usl.y"
{
		yyval.nPtr = opr(0, 2, yyvsp[-1].nPtr, yyvsp[0].nPtr);
	}
break;
case 8:
#line 121 "usl.y"
{
		yyval.nPtr = val((float)(yyvsp[0].attval));
	}
break;
case 9:
#line 126 "usl.y"
{
		yyval.nPtr = val(yyvsp[0].floatval);
	}
break;
case 10:
#line 130 "usl.y"
{
		yyval.nPtr = name(yyvsp[0].attval);
	}
break;
case 11:
#line 134 "usl.y"
{
		yyval.nPtr = opr(OP_ADD, 2, yyvsp[-2].nPtr, yyvsp[0].nPtr);
	}
break;
case 12:
#line 138 "usl.y"
{
		yyval.nPtr = opr(OP_SUB, 2, yyvsp[-2].nPtr, yyvsp[0].nPtr);
	}
break;
case 13:
#line 142 "usl.y"
{
		yyval.nPtr = opr(OP_MUL, 2, yyvsp[-2].nPtr, yyvsp[0].nPtr);
	}
break;
case 14:
#line 147 "usl.y"
{
		yyval.nPtr = opr(OP_MUL, 2, yyvsp[-3].nPtr, yyvsp[-1].nPtr);
	}
break;
case 15:
#line 151 "usl.y"
{
		yyval.nPtr = opr(OP_MUL, 2, yyvsp[-3].nPtr, yyvsp[-1].nPtr);
	}
break;
case 16:
#line 155 "usl.y"
{
		yyval.nPtr = opr(OP_MUL, 2, yyvsp[-3].nPtr, yyvsp[-1].nPtr);
	}
break;
case 17:
#line 159 "usl.y"
{
		yyval.nPtr = opr(OP_DIV, 2, yyvsp[-2].nPtr, yyvsp[0].nPtr);
	}
break;
case 18:
#line 163 "usl.y"
{
		yyval.nPtr = opr(OP_POW, 2, yyvsp[-2].nPtr, yyvsp[0].nPtr);
	}
break;
case 19:
#line 167 "usl.y"
{
		yyval.nPtr = opr(OP_MUL, 2, opr(yyvsp[-3].attval, 2, yyvsp[-4].nPtr, yyvsp[-2].nPtr), opr(yyvsp[-1].attval, 2, yyvsp[-2].nPtr, yyvsp[0].nPtr));
	}
break;
case 20:
#line 171 "usl.y"
{
		yyval.nPtr = opr(yyvsp[-1].attval, 2, yyvsp[-2].nPtr, yyvsp[0].nPtr);
	}
break;
case 21:
#line 175 "usl.y"
{
		yyval.nPtr = yyvsp[-1].nPtr;
	}
break;
case 22:
#line 179 "usl.y"
{
		yyval.nPtr = yyvsp[-1].nPtr;
	}
break;
case 23:
#line 183 "usl.y"
{
		yyval.nPtr = yyvsp[-1].nPtr;
	}
break;
case 24:
#line 187 "usl.y"
{
		yyval.nPtr = opr(OP_CM, 2, yyvsp[-2].nPtr, yyvsp[0].nPtr);
	}
break;
case 25:
#line 191 "usl.y"
{
		yyval.nPtr = opr(yyvsp[-3].attval, 1, yyvsp[-1].nPtr);
	}
break;
case 26:
#line 195 "usl.y"
{
		yyval.nPtr = opr(UMINUS, 1, yyvsp[0].nPtr);
	}
break;
case 27:
#line 202 "usl.y"
{
		yyval.attval = OP_GT;
	}
break;
case 28:
#line 206 "usl.y"
{
		yyval.attval = OP_LT;
	}
break;
case 29:
#line 210 "usl.y"
{
		yyval.attval = OP_GE;
	}
break;
case 30:
#line 214 "usl.y"
{
		yyval.attval = OP_LE;
	}
break;
case 31:
#line 218 "usl.y"
{
		yyval.attval = OP_NE;
	}
break;
case 32:
#line 222 "usl.y"
{
		yyval.attval = OP_EQ;
	}
break;
case 33:
#line 226 "usl.y"
{
		yyval.attval = OP_DELIM;
	}
break;
case 34:
#line 232 "usl.y"
{ 
		yyval.attval = OP_EXP; 			
	}
break;
case 35:
#line 236 "usl.y"
{ 
		yyval.attval = OP_LOG; 			
	}
break;
case 36:
#line 240 "usl.y"
{
		yyval.attval = OP_LN; 			
	}
break;
case 37:
#line 244 "usl.y"
{ 
		yyval.attval = OP_SQRT; 			
	}
break;
case 38:
#line 248 "usl.y"
{
		yyval.attval = OP_SIN;
	}
break;
case 39:
#line 252 "usl.y"
{
		yyval.attval = OP_SINH;
	}
break;
case 40:
#line 256 "usl.y"
{
		yyval.attval = OP_COS;
	}
break;
case 41:
#line 260 "usl.y"
{
		yyval.attval = OP_COSH;
	}
break;
case 42:
#line 264 "usl.y"
{
		yyval.attval = OP_TAN;
	}
break;
case 43:
#line 268 "usl.y"
{
		yyval.attval = OP_TANH;
	}
break;
case 44:
#line 273 "usl.y"
{
		yyval.attval=yyvsp[-1].attval;	
	}
break;
case 45:
#line 277 "usl.y"
{
		yyvsp[0].strval = ToLower (yyvsp[0].strval);
		if (!strcmp("delay",yyvsp[0].strval) || !strcmp("d",yyvsp[0].strval))
		{
			yyval.attval = DELAY;
		}
		else if (!strcmp("throughput",yyvsp[0].strval) || !strcmp("th",yyvsp[0].strval)|| !strcmp("t",yyvsp[0].strval))
		{
			yyval.attval = THROUGHPUT;
		}
		else if (!strcmp("packetloss",yyvsp[0].strval) || !strcmp("pl",yyvsp[0].strval)|| !strcmp("p",yyvsp[0].strval))
		{
			yyval.attval = PACKETLOSS;
		}
		else if (!strcmp("jitter",yyvsp[0].strval) || !strcmp("ji",yyvsp[0].strval)|| !strcmp("j",yyvsp[0].strval))
		{
			yyval.attval = JITTER;
		}
		else if (!strcmp("utility",yyvsp[0].strval) || !strcmp("util",yyvsp[0].strval)|| !strcmp("u",yyvsp[0].strval))
		{
			yyval.attval = UTILITY;
		}
		else if (!strcmp("min_delay",yyvsp[0].strval) || !strcmp("min_d",yyvsp[0].strval)|| !strcmp("min_de",yyvsp[0].strval))
		{
			yyval.attval = MIN_DELAY;
		}
		else if (!strcmp("max_delay",yyvsp[0].strval) || !strcmp("max_d",yyvsp[0].strval)|| !strcmp("max_de",yyvsp[0].strval))
		{
			yyval.attval = MAX_DELAY;
		}
		else if (!strcmp("min_throughput",yyvsp[0].strval) || !strcmp("min_th",yyvsp[0].strval)|| !strcmp("min_t",yyvsp[0].strval))
		{
			yyval.attval = MIN_THROUGHPUT;
		}
		/* initial maximum allowable bandwidth*/
		else if (!strcmp("max_throughput",yyvsp[0].strval) || !strcmp("max_th",yyvsp[0].strval)|| !strcmp("max_t",yyvsp[0].strval))
		{
			yyval.attval = MAX_THROUGHPUT;
		}
		/* adaptive maximum allowable bandwidth*/
		else if (!strcmp("cur_max_throughput",yyvsp[0].strval) || !strcmp("cur_max_th",yyvsp[0].strval)|| !strcmp("cur_max_t",yyvsp[0].strval))
		{
			yyval.attval = CUR_MAX_THROUGHPUT;
		}
		else if (!strcmp("min_utility",yyvsp[0].strval) || !strcmp("min_util",yyvsp[0].strval)|| !strcmp("min_u",yyvsp[0].strval))
		{
			yyval.attval = MIN_UTILITY;
		}
		else if (!strcmp("max_utility",yyvsp[0].strval) || !strcmp("max_util",yyvsp[0].strval)|| !strcmp("max_u",yyvsp[0].strval))
		{
			yyval.attval = MAX_UTILITY;
		}
		else if (!strcmp("min_packetloss",yyvsp[0].strval) || !strcmp("min_pl",yyvsp[0].strval)|| !strcmp("min_p",yyvsp[0].strval))
		{
			yyval.attval = MIN_PACKETLOSS;
		}
		else if (!strcmp("max_packetloss",yyvsp[0].strval) || !strcmp("max_pl",yyvsp[0].strval)|| !strcmp("max_p",yyvsp[0].strval))
		{
			yyval.attval = MAX_PACKETLOSS;
		}
			else if (!strcmp("min_jitter",yyvsp[0].strval) || !strcmp("min_ji",yyvsp[0].strval)|| !strcmp("min_j",yyvsp[0].strval))
		{
			yyval.attval = MIN_JITTER;
		}
		else if (!strcmp("max_jitter",yyvsp[0].strval) || !strcmp("max_ji",yyvsp[0].strval)|| !strcmp("max_j",yyvsp[0].strval))
		{
			yyval.attval = MAX_JITTER;
		}
		else
		{
			/* this is performed when unknown constant values are used.*/
			undefined_name = (char *)malloc(strlen(yyvsp[0].strval));
			if (undefined_name == NULL) 
			{
				printf("no memory for undefined_name\n");
				exit(-1);
			}
			/*strcpy_s(undefined_name, strlen($1), $1);*/
			strcpy(undefined_name, yyvsp[0].strval);
			yyval.attval = NOT_DEFINED;
      
    }
    }
break;
#line 1078 "y_tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
